No puede seleccionar más de 25 temas Los temas deben comenzar con una letra o número, pueden incluir guiones ('-') y pueden tener hasta 35 caracteres de largo.

73 líneas
1.2 KiB

hace 6 años
#!/usr/bin/env bash
hace 6 años
declare -r esc=$'\033'
declare -r c_reset="${esc}[0m"
declare -r c_red="${esc}[31m"
hace 6 años
declare -r fifo='/tmp/sshget.fifo'
declare -A domains=()
declare -A paths=()
declare -a files=()
err() {
printf "${c_red}%s${c_reset}\n" "$*" >&2
}
die() {
exit 1
}
hace 6 años
usage() {
LESS=-FEXR less <<'HELP'
sshget <user@host1:/path/to/search ...>
HELP
}
has() {
hace 6 años
local verbose=0
if [[ $1 = '-v' ]]; then
hace 6 años
verbose=1
shift
fi
hace 6 años
for c; do c="${c%% *}"
if ! command -v "$c" &> /dev/null; then
hace 6 años
(( verbose > 0 )) && err "$c not found"
return 1
fi
done
}
has -v fzf rsync || die
hace 6 años
cleanup() {
[[ -e "$fifo" ]] && rm "$fifo"
}
trap cleanup SIGHUP SIGINT SIGTERM
mkfifo "$fifo"
hace 6 años
if (( $# < 1 )); then
usage
die
fi
hace 6 años
for a; do
hace 6 años
host="${a%:*}"
hace 6 años
path="${a##*:}"
domains+=( ["$a"]="$host" )
paths+=( ["$a"]="$path" )
shift
done
for s in "${!domains[@]}"; do
hace 6 años
ssh "${domains[$s]}" "find ${paths[$s]}" | sed -r "s|^|${domains[$s]}:|" >> "$fifo" &
hace 6 años
done
hace 4 años
mapfile -t files < <(fzf -e --inline-info +s --multi --cycle --bind='Ctrl-A:toggle-all,`:jump' < "$fifo")
hace 6 años
if (( ${#files[@]} )); then
rsync --protect-args -auvzP -e ssh "${files[@]}" .
hace 6 años
fi
cleanup